import { ControllerDefinition, KuzzleRequest, EmbeddedSDK, Plugin } from "kuzzle";
import { AbstractEngine } from "./AbstractEngine";
export declare class EngineController<TPlugin extends Plugin> {
    private engine;
    private context;
    private config;
    private pluginName;
    definition: ControllerDefinition;
    get sdk(): EmbeddedSDK;
    /**
     * @param pluginName Used to define http routes
     * @param plugin Plugin instance
     * @param engine Engine used
     */
    constructor(pluginName: string, plugin: Plugin, engine: AbstractEngine<TPlugin>);
    create(request: KuzzleRequest): Promise<{
        collections: string[];
        index: string;
    }>;
    update(request: KuzzleRequest): Promise<{
        collections: string[];
        index: string;
    }>;
    delete(request: KuzzleRequest): Promise<{
        collections: string[];
        index: string;
    }>;
    list(): Promise<{
        engines: import("./EngineContent").EngineContent[];
    }>;
    exists(request: KuzzleRequest): Promise<{
        exists: boolean;
    }>;
}
